#include <Q2HX711.h>
#include <SPI.h>
#include <SD.h>
#include "RTClib.h"

const int button = 8;
const int led = 9;
char Dateiname[13];
const byte data_pin2 = 5;
const byte clock_pin2 = 4;
const byte data_pin1 = 7;
const byte clock_pin1 = 6;

Q2HX711 sensor1(data_pin1, clock_pin1);
Q2HX711 sensor2(data_pin2, clock_pin2);

File root;
RTC_DS1307 RTC;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  RTC.begin();
  pinMode(button, INPUT);
  pinMode(led, OUTPUT);

  //Initialiseiere SD-Karte
  Serial.print("Initializing SD card...");

  if (!SD.begin(10)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");

  root = SD.open("/");
  Serial.println("SD-Karte geoeffnet");

  createFile();
  Serial.println("Datei erstellt");

  
  delay(1000);
  digitalWrite(led, HIGH);
}

void loop() {
  int buttonState = digitalRead(button);  
  double sensorValue1 = 0.0000000000;
  double sensorValue2 = 0.0000000000;
  double force1 = 0.0000000000;
  double force2 = 0.0000000000;
  double normSensor1 = ((0.0000220895 * sensor1.read()) - 185.0489129717) * 9.81;
  double normSensor2 = ((0.0000222159 * sensor2.read()) - 182.3451235561) * 9.81;

  while(buttonState == digitalRead(button)){
    delay(10);
  }
  delay(3000);
  digitalWrite(led,LOW);

  while(buttonState == digitalRead(button)){
    sensorValue1 = sensor1.read();
    sensorValue2 = sensor2.read();
    force1 = ((0.0000220895 * sensorValue1) - 185.0489129717) * 9.81 - normSensor1;
    force2 = ((0.0000222159 * sensorValue2) - 182.3451235561) * 9.81 - normSensor2;
    String dataString = (String)millis() + ";" + (String) force1 + ";" + (String) force2 + ";";
    Serial.println(dataString);
    
    File dataFile = SD.open(Dateiname, FILE_WRITE);
    dataFile.println(dataString);
    dataFile.close();
  }
  digitalWrite(led, HIGH);
}



void createFile(){
  char filename[12];
  DateTime now = RTC.now();
  int year = now.year();
  int month = now.month();
  int day = now.day();
  int hour = now.hour();
  int minute = now.minute();
  CreateLogfileName(filename, year, month, day, hour, minute); 
  Serial.println(filename);
  Serial.println("Dateinamen ausgegeben");
  for (int i = 0; i < 12; i++) {
    Dateiname[i] = filename[i];
  }
  Dateiname[12] = 0;

  
  if (! SD.exists(Dateiname)) {
    // only open a new file if it doesn't exist
    root = SD.open(Dateiname, FILE_WRITE); 
    //break;  // leave the loop!
  }
}

void CreateLogfileName(char* buffer, int y, int m, int d, int h, int mi){
  sprintf(buffer,"%02d%02d%02d%02d.csv",m,d,h,mi);
}

