#include <Q2HX711.h>
#include <SPI.h>
#include <SD.h>
#include "RTClib.h"

const int button = 8;
const int led = 9;
char Dateiname[13];
const byte data_pin = 7;
const byte clock_pin = 6;

Q2HX711 sensor(data_pin, clock_pin);

File root;
RTC_DS1307 RTC;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  RTC.begin();
  pinMode(button, INPUT);
  pinMode(led, OUTPUT);

  //Initialiseiere SD-Karte
  Serial.print("Initializing SD card...");

  if (!SD.begin(10)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");

  root = SD.open("/");
  Serial.println("SD-Karte geoeffnet");

  createFile();
  Serial.println("Datei erstellt");
  
  delay(1000);
  digitalWrite(led, HIGH);
}

void loop() {
  int buttonState = digitalRead(button);  
  double sensorValue = 0.0000000000;
  double force = 0.0000000000;

  while(buttonState == digitalRead(button)){
    delay(10);
  }
  delay(3000);
  digitalWrite(led,LOW);

  Serial.println(digitalRead(button));
  while(buttonState == digitalRead(button)){
    sensorValue = sensor.read();
    force = ((0.0022115254 * sensorValue - 18416.2395827183) / 1000) * 9.81;
    String dataString = (String)millis() + ";" + (String) force + ";";
    Serial.println(force);
    File dataFile = SD.open(Dateiname, FILE_WRITE);
    dataFile.println(dataString);
    dataFile.close();
  }
  digitalWrite(led, HIGH);
}

void createFile(){
  char filename[12];
  DateTime now = RTC.now();
  int year = now.year();
  int month = now.month();
  int day = now.day();
  int hour = now.hour();
  int minute = now.minute();
  CreateLogfileName(filename, year, month, day, hour, minute); 
  Serial.println(filename);
  Serial.println("Dateinamen ausgegeben");
  for (int i = 0; i < 12; i++) {
    Dateiname[i] = filename[i];
  }
  Dateiname[12] = 0;

  
  if (! SD.exists(Dateiname)) {
    // only open a new file if it doesn't exist
    root = SD.open(Dateiname, FILE_WRITE); 
    //break;  // leave the loop!
  }
}

void CreateLogfileName(char* buffer, int y, int m, int d, int h, int mi){
  sprintf(buffer,"%02d%02d%02d%02d.csv",m,d,h,mi);
}

